window.onload = function () {
    var ctv = getParameterFromURL("ctv"); // obtain keyword from the URL "?ctv="
    var count = 0; // number of subjects whose URI matches keyword
    var datas = new Array();
    var org = $('#aed');
	var update = new Date("1970-01-01");
	var date;
	
    
    // 検索
	$('#search').click(function(){
		showTable();
	});
	$('#key').keypress( function ( e ) {
		if ( e.which == 13 ) {
			showTable();
			return false;
		}
	});
	$('input[name="ocode[]"]').click(function() {
		showTable();
	});
	
	if(ctv != undefined && ctv != "" && $.inArray(ctv,["202070","205419","205435"]) >= 0){
		$('#'+ctv).prop('checked', true);
	}else{
		$('#202070,#205419,#205435').prop('checked', true);
	}
	
	function showTable() {
		count = 0;
		$("#resultCount").empty();
		$('#aed').replaceWith(org.clone());
		var tableRow = '';

		var ocodes = [];
		$('input[name="ocode[]"]:checked').each(function() {
          ocodes.push($(this).val()); 
        });
		var newDatas = datas.filter(function(item, index){
			if ($.inArray(item['Organization_code'],ocodes) >= 0) return true;
		});
		var key = $("#key").val();
		if(key != "") {
			newDatas = newDatas.filter(function(item, index){
				if ((item['設置場所']).indexOf(key) >= 0) return true;
			});
		}
		
		for(var num in newDatas) {
			var data = newDatas[num];
			tableRow = '<tr id="rc">'
			// 行の内容を生成
        	tableRow += '<td>' + data['分類'] + '</td>';
        	tableRow += '<td>' + data['設置場所'] + '</td>';
        	tableRow += '<td>' + data['住所'] + '</td>';
        	tableRow += '<td>' + (data['電話番号'] ? '<a href="tel:' + data['電話番号'] + '">' + data['電話番号'] + '</a>' : '&#160;') + '</td>';
        	tableRow += '<td><a href="http://www.google.com/maps?q=' + data['lat'] + ',' + data['long'] + '" target="_blank">地図</a></td>';
        	tableRow += '<td>' + (data['備考'] ? data['備考'] : '&#160;') + '</td>';
        	tableRow += '</tr>';
        	$('#aed tr:last').after(tableRow);
        	++count;
		}
		
		if (count > 0) {
        	$("#resultCount").append(count + " 件のデータを表示しています。");
    	}
		
	};
    
    // Work loop
    $.each(LinkData.getWorks(), function (workKey, workValue) {
        // File loop
        $.each(LinkData.getFiles(workValue), function (fileKey, fileValue) {
            // Subject loop
            $.each(LinkData.getSubjects(workValue, fileValue), function (subjKey, subjValue) {
            	var data = {};
                
                $.each(LinkData.getTriplesBySubject(workValue, fileValue, subjValue), function (tripleKey, tripleValue) {
                    var prop = tripleValue.property;
                    var obj = tripleValue.object;
                    var propertyName = getLastName(prop);
                    data[propertyName] = obj;
                });
				
				date = new Date(data['UpdateDate']);
				if(date > update) update = date;
				
                datas.push(data);
            });
        });
    });
    
	$('#title').append("【" + update.getFullYear() + "年" + (update.getMonth()+1) + "月" +  update.getDate() + "日現在】");
    showTable();
};

// Get a parameter value in URL (e.g. ?paramString=value )
function getParameterFromURL(paramString)
{
    var value = "";
    var topWindow = top.window.location.search;
    if (topWindow) {
        var q = decodeURIComponent(topWindow.substring(1, topWindow.length)).split("&");
        for (var i = 0; i < q.length; i++) {
            var r = q[i].split("=");
            if (r[0] == paramString)
                value = r[1];
        }
    }
    return value;
}

// Highlight keyword in the string
function highlight(string, keyword)
{
    if (keyword.length > 0) {
        var ss = string.split(keyword);
        var len = ss.length;
        if (len > 1) {
            string = ss[0];
            for (i = 1; i < len; i++)
                string += "<span class=\"highlight\">" + keyword + "</span>" + ss[i];
        }
    }
    return string;
}

// get the last name of the string separated with # and /
function getLastName(string)
{
    string = decodeURIComponent(string);
    var sharp = string.split("#");
    var slash = sharp[sharp.length - 1].split("/");
    var lastName = slash[slash.length - 1];
    return lastName;
}
